<?php

namespace IQDEV\ElasticSearchTests\Service;

use IQDEV\ElasticSearch\SearchService;
use IQDEV\ElasticSearch\Config\BaseConfiguration as Configuration;
use IQDEV\ElasticSearchTests\Factory\ClientFactory;
use IQDEV\Search\Query\SearchQueryHandler;

class SearchClient
{
    private function __construct() { }

    protected static SearchQueryHandler $oInstance;

    public static function getInstance(): SearchQueryHandler
    {
        if (!isset(static::$oInstance)) {
            static::$oInstance = new SearchQueryHandler(
                new SearchService(
                    ClientFactory::create(),
                    new Configuration(),
                )
            );
        }
        
        return static::$oInstance;
    }
}